#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

#package require BioTcl
#package require Extral
package require Tk

set scoremin 0.05
set scoremax 2
set scoretype decr
set scorefield expect
#
set scoremin 90
set scoremax 100
set scoretype incr
set scorefield similarity

proc hls2rgb {h l s} {
   # h, l and s are floats between 0.0 and 1.0, ditto for r, g and b
   # h = 0   => red
   # h = 1/3 => green
   # h = 2/3 => blue
   set h6 [expr {($h-floor($h))*6}]
   set r [expr {  $h6 <= 3 ? 2-$h6
                           : $h6-4}]
   set g [expr {  $h6 <= 2 ? $h6
                           : $h6 <= 5 ? 4-$h6
                           : $h6-6}]
   set b [expr {  $h6 <= 1 ? -$h6
                           : $h6 <= 4 ? $h6-2
                           : 6-$h6}]
   set r [expr {$r < 0.0 ? 0.0 : $r > 1.0 ? 1.0 : double($r)}]
   set g [expr {$g < 0.0 ? 0.0 : $g > 1.0 ? 1.0 : double($g)}]
   set b [expr {$b < 0.0 ? 0.0 : $b > 1.0 ? 1.0 : double($b)}]
   set r [expr {(($r-1)*$s+1)*$l}]
   set g [expr {(($g-1)*$s+1)*$l}]
   set b [expr {(($b-1)*$s+1)*$l}]
   return [list $r $g $b]
}

proc hls2tk {h l s} {
    set rgb [hls2rgb $h $l $s]
    foreach c $rgb {
       set intc [expr {int($c * 256)}]
       if {$intc == 256} { set intc 255 }
       set c1 [format %1X $intc]
       if {[string length $c1] == 1} {set c1 "0$c1"}
       append init $c1
    }
    return #$init
}

# code
if 0 {
set argv /data/peter/cblast/mp_vs_mt.fasta2seq
}

if {![llength $argv]} {
	set file [tk_getOpenFile]
} else {
	set file [lindex $argv 0]
}

set f [open $file]
set data [fasta_parse $f]

canvas .c
.c configure -xscrollcommand {.h set} -yscrollcommand {.v set}
scrollbar .v -command {.c yview}
scrollbar .h -orient horizontal -command {.c xview}
grid .c .v -sticky nwse
grid .h -sticky nwse
grid columnconfigure . 0 -weight 1
grid rowconfigure . 0 -weight 1

.c delete all
set num 0
foreach line $data {
	array set a $line
	set score $a($scorefield)
	switch $scoretype {
		incr {
			set score [expr {0.75 - 0.75*($score-$scoremin)/($scoremax-$scoremin)}]
		}
		decr {
			set score [expr {0.75*($score-$scoremin)/($scoremax-$scoremin)}]
		}
	}
	if {$score > 0.7} {set score 0.75}
	if {$score < 0} {set score 0}
	set color [hls2tk $score 0.9 1]
#	if {$a(expect) < 0.1} {
#		set color black
#	} else {
#		set color red
#	}
	if {!$a(complement)} {
		.c create line $a(start) $a(hit_start) $a(end) $a(hit_end) -tags [list [list p $num] "$a(start)-$a(end) : $a(hit_start)-$a(hit_end)" lines] -fill $color -width 1
	} else {
		.c create line $a(start) $a(hit_end) $a(end) $a(hit_start) -tags [list [list p $num] "$a(start)-$a(end) : $a(hit_start)-$a(hit_end)" lines] -fill $color -width 1
	}
	incr num
}

.c create text 0 0 -text "" -tags text
foreach {x y xe ye} [.c bbox lines] break
.c create rectangle 0 0 $xe $ye -tags lines -width 1
if {$xe < $ye} {set max $ye} else {set max $xe}
set scale [expr {1000.0/$max}]
.c scale all 0 0 $scale -$scale
foreach {x y xe ye} [.c bbox lines] break
.c move all 1 [expr {1-$y}]
.c configure -scrollregion [.c bbox lines]

bind .c <Motion> {
	set x [.c canvasx %x]
	set y [.c canvasy %y]
	set r 10
	set id [lindex [.c find overlapping [expr {$x-$r}] [expr {$y-$r}] [expr {$x+$r}] [expr {$y+$r}]] 0]
	if {[string is int $id]} {
		set id [.c find closest $x $y]
		.c coords text [expr {$x-2}] [expr {$y+2}]
		.c itemconfigure text -text [lindex [.c itemcget $id -tags] 1] -anchor ne
	} else {
		.c itemconfigure text -text {} -anchor ne
	}
}

bind .c <Button-1> {
	set sx [.c canvasx %x]
	set sy [.c canvasy %y]
}

bind .c <B1-Motion> {
	set nx [.c canvasx %x]
	set ny [.c canvasy %y]
	foreach {x y xe ye} [.c bbox lines] break
	if {$xe < $ye} {set max $ye} else {set max $xe}
	set move [expr {$sx-$nx}]
	set scale [expr {1-$move*0.01}]
puts $max:$scale
	if {(($max > 100) || ($scale > 1))&&($scale > 0)} {
		.c scale all 0 0 $scale $scale
		foreach {x y xe ye} [.c bbox lines] break
		.c configure -scrollregion [.c bbox lines]
	}
	set sx $nx
	set sy $ny
}

.c configure -takefocus 1
focus .c
bind .c <Key-p> {
	set file [tk_getSaveFile]
	foreach {x1 y1 x2 y2} [.c cget -scrollregion] break
	set h [expr {$y2-$y1}]
	set w [expr {$x2-$x1}]
	.c postscript -file $file -height $h -width $w -x $x1 -y $y1 -pagewidth 100c
}
