proc matrix_make_alicost {db query cutoff} {
	set matrixid [matrix_new $db]
	set matrixcells [$db get $matrixid _cells]
	set fts [$db find -class ft $query]
	$db set $matrixid type alicost \
		date [time_scan [clock format [clock seconds]]] \
		cutoff $cutoff
	set i 1
	foreach ft1 $fts {
		puts $ft1
		foreach ft2 [lrange $fts 0 [expr {$i-1}]] {
			set id [$db find -class $matrixcells [list [list _ft1 == $ft2] and [list _ft2 == $ft1]]]
			if [llength $id] {
				set cost [$db get $id value]
				set cell [$db new $matrixcells]
				$db set $cell _matrix $id _ft1 $ft1 _ft2 $ft2 value $cost
			}
		}
		foreach ft2 [lrange $fts $i end] {
			set seq1 [seqdb_proteinseq $db $ft1]
			set seq2 [seqdb_proteinseq $db $ft2]
			set cost [ali_fcost -matrix ${bio::dir}/conf/matrices/pam120.mat -cutoff $cutoff $seq1 [list temp $seq2]]
			if [llength $cost] {
				set cost [lindex $cost end]
				set cell [$db new $matrixcells]
				$db set $cell _matrix $matrixid _ft1 $ft1 _ft2 $ft2 value $cost
			}
		}
		incr i
	}
	return $matrixid
}

