proc bio_dcseali {option args} {
	variable dcseali
	switch $option {
		open {
			if {[llength $args] != 1} {
				return -code error "wrong # args: should be \"dcseali open file\""
			}
			set file [lindex $args 0]
			set f [open $file]
			set line [gets $f]
			set dcseali($f,type) [string index $line 0]
			set line [string range $line 1 end]
			set dcseali($f,start) [lindex $line 0]
			set dcseali($f,end) [lindex $line 1]
			set len [expr {$dcseali($f,end)-$dcseali($f,start)+1}]
			set dcseali($f,len) $len
			gets $f
			gets $f
			gets $f
			while {![eof $f]} {
				lappend pos [tell $f]
				set line [gets $f]
				if {"$line" == ""} break
				lappend orgs [string trimright [string range $line [expr {2*$len+7}] end]]
			}
			set dcseali($f,pos) $pos
			set dcseali($f,orgs) $orgs
			return $f
		}
		orgs {
			if {[llength $args] != 1} {
				return -code error "wrong # args: should be \"dcseali orgs channelId\""
			}
			set f [lindex $args 0]
			return $dcseali($f,orgs)
		}
		seq {
			if {[llength $args] != 2} {
				return -code error "wrong # args: should be \"dcseali seq channelId org\""
			}
			set f [lindex $args 0]
			set org [string trimright [lindex $args 1]]
			set pos [lsearch $dcseali($f,orgs) $org]
			if {$pos == -1} {return -code error "Organism \"$org\" not found"}
			set pos [lindex $dcseali($f,pos) $pos]
			seek $f $pos
			set line [gets $f]
			return [string range $line 0 [expr {2*$dcseali($f,len)}]]
		}
		close {
			if {[llength $args] != 1} {
				return -code error "wrong # args: should be \"dcseali close channelId\""
			}
			set f [lindex $args 0]
			close $f
			foreach name [array names dcseali $f,*] {
				unset dcseali($name)
			}
		}
		default {
			error "bad option \"$option\": must be open, orgs, seq or close"
		}
	}
}
