Class subclass FastaFile

FastaFile method init {{file {}}} {
	if {[string length $file]} {$object open $file}
}

FastaFile method close {} {
	private $object data f
	unset -nocomplain data
	unset -nocomplain idarray
	if {[info exists f]} {
		close $f
		unset f
	}
}

FastaFile method destroy {} {
	private $object f
	if {[info exists f]} {close $f}
}

FastaFile method open {file} {
	private $object f data
	$object close
	set f [open $file]
	set num 0
	set data {}
	while 1 {
		set line [gets $f]
		if {[string equal [string index $line 0] >] || [eof $f]} {
			if {[info exists seq]} {
				lappend data [list $name $seq [file_linestart $f $line]]
				log "$num $name"
				incr num
			}
			if {[eof $f]} break
			set name [string range $line 1 end]
			set seq [tell $f]
		}
	}
	fconfigure $f -translation binary -encoding binary
}

FastaFile method index {name} {
	private $object data
	if {[isint $name]} {return $name}
	return [lsearch [list_subindex $data 0] $name]
}

#FastaFile method get {id field} {
#	if {![isint $id]} {
#		private $object idarray
#		set id $idarray($id)
#	}
#	upvar #0 [privatevar $object data_$id] data
#	return $data($field)	
#}

FastaFile method names {id} {
	return {}
}

FastaFile method list {{field acc}} {
	private $object f data
	set result {}
	foreach line $data {
		lappend result [lindex $line 0]
	}
	return $result
}

FastaFile method fields {} {
	set result {}
	return $result
}

FastaFile method fsequence {id} {
	private $object f data
	set id [$object index $id]
	foreach {name start end} [lindex $data $id] break
	seek $f $start
	return [read $f [expr {$end-$start}]]
}

FastaFile method sequence {id} {
	set seq [$object fsequence $id]
	regsub -all {[^A-Za-z]} $seq {} seq
	return $seq
}

FastaFile method ffeatures {id} {
	return {}
}

FastaFile method features {id} {
	return {}
}

