proc bio_geneticcodes {} {
	set result [dirglob $::bio::dir/conf/geneticcodes *]
	regsub -all {([0-9]+)_} $result {\1 } result
	regsub -all {\.txt} $result {} result
	return $result
}

proc bio_geneticcodetable {{code {}}} {
	set clen [llength $code]
	if {$clen > 1} {
		upvar #0 ::bio::transl_table_$code table
		array set table $code
		return ::bio::transl_table_$code
	} else {
		if {$clen == 0} {
			set file $::bio::dir/conf/geneticcodes/1_Standard.txt
			set num 1
		} else {
			if [isint $code] {
				set file [lindex [glob $::bio::dir/conf/geneticcodes/${code}_*.txt] 0]
				set num $code
			} else {
				set file [lindex [glob $::bio::dir/conf/geneticcodes/*_$code.txt] 0]
				regexp {[0-9]+} $file num
			}
		}
		if {[string length $file] == 0} {
			error "Translation table for $code not found"
		}
		upvar #0 ::bio::transl_table_$num table
		if ![info exists table] {
			array set table [file_read $file]
		}
		return ::bio::transl_table_$num
	}
}
